#pragma once

#include <GL/glew.h>
#include "wx/wx.h"
#include "wx/glcanvas.h"

#define CHAGAPP_DISPLAY_TIMER_MS 100

class CHAGApp; 

class wxGLPane : public wxGLCanvas
{
    wxGLContext*	m_context;
	CHAGApp *m_chagApp; 
	bool m_firstFrame; 
public:
	wxGLPane (CHAGApp *chagApp, wxFrame* parent, int* args);
	virtual ~wxGLPane() { delete m_context; };

	wxTimer *m_display_timer; 
	bool m_frame_finished; 
	void onDisplayTimer(wxTimerEvent &event) { m_display_timer->Stop(); if(m_frame_finished) { m_frame_finished = false; Refresh(); m_display_timer->Start(); } } //m_display_timer->Start(CHAGAPP_DISPLAY_TIMER_MS); }
	void reshape(wxSizeEvent &evt);
	void display(wxPaintEvent &evt); 
	int m_oldMouseX; 
	int m_oldMouseY; 
	float m_mouseSensitivity; 
	float m_forwardVelocity; 
	float m_strafeVelocity; 
	float m_ascentVelocity; 
	bool m_shiftDown; 
	void leftMouseDown(wxMouseEvent &event); 
	void leftMouseUp(wxMouseEvent &event); 
	void mouseMoved(wxMouseEvent &event);
	void keyPressed(wxKeyEvent &event); 
	void keyReleased(wxKeyEvent &event); 

	DECLARE_EVENT_TABLE()
};

