#include "streamoperators.h"

using namespace std;
using namespace chag; 

namespace chag
{
	ostream& operator << (ostream& os, const float3& v)
	{
	  os << "(" << v.x << "," << v.y << "," << v.z << ")";
	  return os;
	}
	istream& operator >> (istream &i, float3 &v)
	{
		char dummy; 
		i >> dummy >> v.x >> dummy >> v.y >> dummy >> v.z >> dummy; 
		return i; 
	}
	ostream& operator << (ostream& os, const float4& v)
	{
	  os << "(" << v.x << "," << v.y << "," << v.z << "," << v.w << ")";
	  return os;
	}
	ostream& operator << (ostream& os, const float3x3& m)
	{
		os << "[" 
		  << m.c1.x << " " << m.c2.x << " " << m.c3.x << " " 
		  << m.c1.y << " " << m.c2.y << " " << m.c3.y << " " 
		  << m.c1.z << " " << m.c2.z << " " << m.c3.z << "]"; 
		return os;
	}

	istream & operator >> ( istream &i, float3x3& m)
	{
		char dummy;
		i >> dummy
		>> m.c1.x >> m.c2.x >> m.c3.x
		>> m.c1.y >> m.c2.y >> m.c3.y
		>> m.c1.z >> m.c2.z >> m.c3.z 
		>> dummy; 
		return i;
	}
}