#pragma once
#include <iostream>
#include <fstream>
#include <string>
#include <map>
#include <vector>
#include <assert.h>
#include "view.h"
#include "linmath/linmath.h"

class Light 
{
public: 
	Light() {
		size = chag::make_vector(0.001f, 0.001f); 
	};
	view myView; 
	float intensity; 
	chag::float3 color; 
	chag::float2 size; 
	float spotlight_total_width;
	float spotlight_falloff_start; 
	std::string name; 
};

class Animation
{
public:
	Animation(void);
	~Animation(void);
	void load(std::string filename); 

	class transform
	{
	public: 
		std::string m_parentname; 
		chag::float3 m_pos; 
		chag::Quaternion m_rot;
	};

	class cameraTransform : public transform
	{
	public: 
		float m_fov; 
	};

	class lightTransform : public transform
	{
	public: 
		float m_fov; 
		float m_aspectratio; 
		chag::float3 m_color;
		float m_intensity; 
	};

	int m_nofFrames; 
	std::map<std::string, std::vector<cameraTransform>> m_cameras; 
	std::map<std::string, std::vector<lightTransform>> m_lights; 
	std::map<std::string, std::vector<transform>> m_nodes; 

	std::vector<std::string> getCameraNames(); 
	std::vector<std::string> getLightNames(); 
	std::vector<std::string> getNodeNames(); 

	view getCamera(std::string, float time);
	Light getLight(std::string, float time);
	view getNode(std::string, float time); 
};
