#pragma once
#include "view.h"

class __declspec(dllexport) CameraController
{
public:
	CameraController(void);
	~CameraController(void);
	void setCamera(view *camera);
	void setTarget(chag::Orientation *target);
	bool keyboard(unsigned char c, int x, int y, bool down);
	bool isShiftPressed(); 
	bool mouse(int button, int state, int x, int y);
	bool motion(int x, int y);
	bool special(int key, int x, int y);
	bool passiveMotion(int x, int y);
	void update(float dt); 

	enum ControllerType { FREE, ORBITING } m_controllerType; 
	void setControllerType(ControllerType t) { m_controllerType = t; };
	void setCameraTarget(chag::float3 target);
	void visualize(); 

	float *m_sceneUnitMultiplier; 
private: 
	view *m_camera; 
	chag::Orientation *m_target; 
	int m_oldMouseX; 
	int m_oldMouseY; 
	float m_mouseSensitivity; 
	bool m_mouseRightPressed; 
	bool m_mouseLeftPressed; 
	bool m_mouseMiddlePressed; 
	bool m_ctrlPressed; 
	float m_forwardVelocity; 
	float m_strafeVelocity; 
	float m_ascentVelocity; 
};
