#ifndef _ChagGlUtils_h_
#define _ChagGlUtils_h_

#include <GL/glew.h>
#include <linmath/int2.h>
#include <linmath/int3.h>
#include <linmath/float3x3.h>
#include <linmath/float4x4.h>
#include <linmath/float3.h>
#include <linmath/float2.h>

namespace chag
{

inline void glColor(const chag::float4 &c)
{
	glColor4fv(&c.x);
}
inline void glColor(const chag::float3 &c)
{
	glColor3fv(&c.x);
}
inline void glVertexF3(const chag::float3 &v)
{
	glVertex3fv(&v.x);
}
inline void glVertex(const chag::float3 &v)
{
	glVertex3fv(&v.x);
}
/*
inline void glVertex(const chag::uint2 &v)
{
	glVertex2iv(reinterpret_cast<const GLint*>(&v.x));
}*/
inline void glLoadMatrix(const chag::float4x4 &m)
{
	glLoadMatrixf(&m.c1.x);
}
inline void glMultMatrix(const chag::float4x4 &m)
{
	glMultMatrixf(&m.c1.x);
}
inline void glTranslate(const chag::float3 &v)
{
	glTranslatef(v.x, v.y, v.z);
}


}; // namespace chag


#endif // _ChagGlUtils_h_
