#pragma once
#include <iostream>
#include <fstream>
#include <string>
#include <vector>
#include <map>
#include "GLSLProgramObject.h"

class GLSLProgramManager
{
private: 																																																																															
	std::vector<std::string> m_fullSource;
	std::string extractShader(std::string shaderName); 
	std::string m_filename; 

	class LoadedProgram {
	public: 
		std::string vertexShader;
		std::string geometryShader; 
		std::string fragmentShader;
		GLenum geomIn;
		GLenum geomOut; 
		unsigned int verticesIn; 
		GLSLProgramObject *programObject; 
	};
	std::vector<LoadedProgram> m_loadedPrograms;

public:
	GLSLProgramManager(std::string filename);
	void setFile(std::string filename);
	~GLSLProgramManager(void);
	std::map<std::string, std::string> m_defines;
	void compileProgram(const std::string &vertex_shader, 
						const std::string &fragment_shader,
						GLSLProgramObject *program);
	void compileProgram(const std::string &vertex_shader, 
						const std::string &geometry_shader, 
						const std::string &fragment_shader,
				        GLenum gsInput, 
						GLenum gsOutput,
						unsigned int verticesOut,
						GLSLProgramObject *program);
	void reload(); 
	GLSLProgramObject * getProgramObject(const std::string &vertex_shader, 
										 const std::string &fragment_shader);
	GLSLProgramObject * getProgramObject(const std::string &vertex_shader, 
										 const std::string &geometry_shader, 
										 const std::string &fragment_shader,
						                 GLenum gsInput, 
										 GLenum gsOutput,
										 unsigned int verticesOut);

  void setPreprocDef(const char *name, int value);
  void setPreprocDef(const char *name, bool value);
};
