#pragma once
#include <iostream>
#include <time.h>
#include <string>
#include <fstream>

///////////////////////////////////////////////////////////////////////////////
// Simple logging
///////////////////////////////////////////////////////////////////////////////
class Log {
public:
	static std::string timeString() {
		time_t rawtime;
		struct tm * timeinfo;
		char buffer [80];
		time (&rawtime);
		timeinfo = localtime(&rawtime);
		strftime (buffer,80,"[%I:%M:%S:%p]",timeinfo);
		return std::string(buffer);
	}
    enum Level { Warning, Error, Info };
	static std::ofstream os; 
    static std::ostream& GetStream() { 
		if(!os.is_open()) {
			os.open("log.txt"); 
		}
		return std::cout; 
	}
	static bool IsLevelActive(Level l) { return true; }
};

#ifndef NO_LOG
#define LOG_ERROR(M)   do { if (Log::IsLevelActive(Log::Error))		{ (Log::GetStream() << Log::timeString().c_str() << " ERROR  : " << M << "\n"); (Log::os << Log::timeString().c_str() << " ERROR  : " << M << "\n"); }} while (false)
#define LOG_INFO(M)    do { if (Log::IsLevelActive(Log::Info))		{ (Log::GetStream() << Log::timeString().c_str() << " INFO   : " << M << "\n"); (Log::os << Log::timeString().c_str() << " INFO   : " << M << "\n"); }} while (false)
#define LOG_WARNING(M) do { if (Log::IsLevelActive(Log::Warning))	{ (Log::GetStream() << Log::timeString().c_str() << " WARNING: " << M << "\n"); (Log::os << Log::timeString().c_str() << " WARNING: " << M << "\n"); }} while (false)
#else
#define LOG_ERROR(M)
#define LOG_INFO(M)
#define LOG_WARNING(M)
#endif