#include "gldebug.h"
#include <iostream>
using namespace std; 

void CALLBACK	debugMessageCallback (GLenum source,
									  GLenum type,
                                      GLuint id,
                                      GLenum severity,
                                      GLsizei length,
                                      const GLchar* message,
                                      GLvoid* userParam)
{
	char debSource[16], debType[20], debSev[50];
	if(source == GL_DEBUG_SOURCE_API_ARB)
		strcpy_s(debSource, "OpenGL");
	else if(source == GL_DEBUG_SOURCE_WINDOW_SYSTEM_ARB)
		strcpy_s(debSource, "Windows");
	else if(source == GL_DEBUG_SOURCE_SHADER_COMPILER_ARB)
		strcpy_s(debSource, "Shader Compiler");
	else if(source == GL_DEBUG_SOURCE_THIRD_PARTY_ARB)
		strcpy_s(debSource, "Third Party");
	else if(source == GL_DEBUG_SOURCE_APPLICATION_ARB)
		strcpy_s(debSource, "Application");
	else if(source == GL_DEBUG_SOURCE_OTHER_ARB)
		strcpy_s(debSource, "Other");

	if(type == GL_DEBUG_TYPE_ERROR_ARB)
		strcpy_s(debType, "Error");
	else if(type == GL_DEBUG_TYPE_DEPRECATED_BEHAVIOR_ARB)
		strcpy_s(debType, "Deprecated behavior");
	else if(type == GL_DEBUG_TYPE_UNDEFINED_BEHAVIOR_ARB)
		strcpy_s(debType, "Undefined behavior");
	else if(type == GL_DEBUG_TYPE_PORTABILITY_ARB)
		strcpy_s(debType, "Portability");
	else if(type == GL_DEBUG_TYPE_PERFORMANCE_ARB)
		strcpy_s(debType, "Performance");
	else if(type == GL_DEBUG_TYPE_OTHER_ARB)
		strcpy_s(debType, "Other");

	if(severity == GL_DEBUG_SEVERITY_HIGH_ARB)
		strcpy_s(debSev, "High");
	else if(severity == GL_DEBUG_SEVERITY_MEDIUM_ARB)
		strcpy_s(debSev, "Medium");
	else if(severity == GL_DEBUG_SEVERITY_LOW_ARB)
		strcpy_s(debSev, "Low");

	if(type == GL_DEBUG_TYPE_OTHER_ARB) {
		//cout << "Message: (" << debSource << "): " << message << endl;  
	}
	else {
		__debugbreak();
		cout << "GL Error:\n"
			 << "  Source:   " << debSource << endl
			 << "  Type:     " << debType << endl
			 << "  ID:       " << id << endl
			 << "  Severity: " << debSev << endl
			 << "  Message:  " << message << endl; 
	}
	return;
}