#ifndef _chag_Orientation_h
#define _chag_Orientation_h

#include "linmath/float2.h"
#include "linmath/float3.h"
#include "linmath/float3x3.h"
#include "linmath/float4.h"
#include "linmath/float4x4.h"
#include <GL/glew.h>

namespace chag
{
class Orientation
{
public:
	float3x3 R;
	float3   pos;

	Orientation() { R = make_identity<float3x3>(); pos = make_vector(0.0f, 0.0f, 0.0f); };
	Orientation(float3 pos, float3 dir, float3 up);
	void lookAt(float3 pos, float3 dir, float3 up);
	void lookAt(float3 pos, float3 dir);

	float4x4 get_MV(); 
	float4x4 get_MV_inv();
	void set_as_modelview();

	void roll(float angle);
	void yaw(float angle);
	void pitch(float angle);
};
typedef Orientation orientation; 

std::ostream& operator << (std::ostream& os, const chag::Orientation& o);
std::istream& operator >> (std::istream& is, chag::Orientation& o); 

} // namespace chag

#endif // _chag_Orientation_h
